Package org.apache.sling.caconfig.spi.metadata

## Class ConfigurationMetadata

- java.lang.Object
- - org.apache.sling.caconfig.spi.metadata.ConfigurationMetadata

    @ProviderType
    public final class ConfigurationMetadata
    extends Object

Defines a configuration.

### Constructor Summary

Constructors
`ConfigurationMetadata​(@NotNull String name, Collection<PropertyMetadata<?>> propertyMetadata, boolean collection)`

### Method Summary

All Methods Instance Methods Concrete Methods
`T` `description​(String description)`
`String` `getDescription()`
`String` `getLabel()`
`@NotNull String` `getName()`
`Map<String,​String>` `getProperties()`
`Map<String,​PropertyMetadata<?>>` `getPropertyMetadata()`
`boolean` `isCollection()`
`boolean` `isSingleton()`
`T` `label​(String label)`
`T` `properties​(Map<String,​String> properties)`
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ConfigurationMetadata

    public ConfigurationMetadata​(@NotNull
                                 @NotNull String name,
                                 Collection<PropertyMetadata<?>> propertyMetadata,
                                 boolean collection)

Parameters:
  `name` - Configuration name
  `propertyMetadata` - Property metadata
  `collection` - Collection

### Method Detail

#### isSingleton

    public boolean isSingleton()

Returns:
  true if configuration is singleton

#### isCollection

    public boolean isCollection()

Returns:
  true if configuration is collection

#### getPropertyMetadata

    public Map<String,​PropertyMetadata<?>> getPropertyMetadata()

Returns:
  Configuration properties

#### getName

    @NotNull
    public @NotNull String getName()

Returns:
  Parameter name

#### getLabel

    public String getLabel()

Returns:
  Label

#### label

    public T label​(String label)

Parameters:
  `label` - Label
Returns:
  this;

#### getDescription

    public String getDescription()

Returns:
  Description

#### description

    public T description​(String description)

Parameters:
  `description` - Description
Returns:
  this;

#### getProperties

    public Map<String,​String> getProperties()

Returns:
  Further properties for documentation and configuration of behavior in configuration editor.

#### properties

    public T properties​(Map<String,​String> properties)

Parameters:
  `properties` - Further properties for documentation and configuration of behavior in configuration editor.
Returns:
  this;

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`